<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="actor"/>
            <ui:param name="controllerName" value="#{appliesToActorManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.ActorsFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <h:form id="filterform" styleClass="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="domain"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Domain']}</ui:define>
                        <h:selectOneMenu id="domain" styleClass="form-control gzl-select-text"
                                         value="#{appliesToActorManager.selectedDomain}">
                            <s:selectItems var="domainAvailable"
                                           label="#{domainAvailable}"
                                           value="#{appliesToActorManager.getDomainsAvailable()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,actorsForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="ip"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                        </ui:define>
                        <h:selectOneMenu id="ip" styleClass="form-control gzl-select-text"
                                         value="#{appliesToActorManager.selectedIntegrationProfileName}">
                            <s:selectItems var="iP" label="#{iP}"
                                           value="#{appliesToActorManager.getIntegrationProfilesNames()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,actorsForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </h:form>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{appliesToActorManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="col-md-3">
                    <h:form id="actorsForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{appliesToActorManager.actors.size} filtered actors"/>
                            </ui:define>
                            <rich:dataTable rows="20" id="idTests" var="currentActor"
                                            value="#{appliesToActorManager.actors}" render="idTestsDs">
                                <g:column sortBy="#{'keyword'}">
                                    <ui:define name="header">#{messages['gazelle.simulator.Actor']}</ui:define>
                                    <h:outputText
                                            value="#{currentActor.keyword} - #{currentActor.name}"
                                            style="#{appliesToActorManager.getSelectedActor().getId() == currentActor.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Covered']}
                                    </ui:define>
                                    <h:outputText
                                            value="#{appliesToActorManager.isActorCovered(currentActor.keyword)}"/>
                                </g:column>
                                <g:column>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                            immdediate="true"
                                            actionListener="#{appliesToActorManager.setSelectedActor(currentActor)}"
                                            render="description,idSchemesForm,actorsForm,ruleCoverage"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="idTestsDs"/>
                                        <ui:param name="dataTableId" value="idTests"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>
                    </h:form>
                </div>
                <div class="col-md-4">
                    <h:form id="description">
                        <h:panelGroup rendered="#{appliesToActorManager.isActorSelected()}">
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    <h:outputText
                                            value="#{messages['net.ihe.gazelle.assertion-manager.DescriptionOf']} #{appliesToActorManager.getSelectedActor().getName()}"/>
                                </ui:define>
                                <g:safehtml
                                        value="#{appliesToActorManager.getSelectedActorDescription()}"/>
                            </ui:decorate>
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    #{messages['gazelle.simulator.Actor']}
                                    (#{appliesToActorManager.getSelectedActor().getKeyword()})
                                    #{messages['net.ihe.gazelle.assertion-manager.IsLinkedToThoseAssertions']}
                                </ui:define>
                                <rich:dataTable rows="20" id="ruleCoverage"
                                                var="assertionCoverage"
                                                rendered="#{appliesToActorManager.isActorSelected()}"
                                                value="#{appliesToActorManager.assertionsOfSelectedActor()}">
                                    <g:column id="action">
                                        <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                           rendered="#{appliesToActorManager.isSelectedActorLinkedTo(assertionCoverage.assertion.id)}"
                                                           actionListener="#{appliesToActorManager.unlinkSelectedActorFrom(assertionCoverage.assertion.id)}"
                                                           immdediate="true"
                                                           value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                           render="action,actorsForm,description,idSchemesForm"/>
                                    </g:column>
                                    <g:column
                                            sortBy="#{assertionCoverage.assertion.target.idScheme}"
                                            sortOrder="ascending">
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                        </ui:define>
                                        <a4j:commandLink immdediate="true"
                                                         value="#{assertionCoverage.assertion.target.idScheme}"
                                                         actionListener="#{appliesToActorManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                         render="idSchemesForm,description,filterform"/>
                                    </g:column>
                                    <g:column sortBy="#{assertionCoverage.assertion.assertionId}"
                                              sortOrder="ascending">
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                        </ui:define>
                                        <h:outputLink id="linkAssertion" target="_assertion"
                                                      title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                      value="#{request.contextPath}/assertions/show.seam">
                                            <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                            <h:outputText
                                                    value="#{assertionCoverage.assertion.assertionId}"/>
                                        </h:outputLink>
                                    </g:column>
                                </rich:dataTable>
                            </ui:decorate>
                        </h:panelGroup>
                    </h:form>
                </div>
                <div class="col-md-5">
                    <h:form id="idSchemesForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                Assertions
                            </ui:define>
                            <ui:include src="../_linkAll.xhtml">
                                <ui:param name="manager" value="#{appliesToActorManager}"/>
                            </ui:include>
                            <rich:dataTable rows="20" id="idScheme" var="assertion"
                                            value="#{appliesToActorManager.assertions}" render="idSchemeDs">
                                <g:column id="action"
                                          rendered="#{appliesToActorManager.isActorSelected()}">
                                    <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                                       disabled="#{!appliesToActorManager.isActorSelected()}"
                                                       rendered="#{not appliesToActorManager.isSelectedActorLinkedTo(assertion.id) }"
                                                       actionListener="#{appliesToActorManager.linkSelectedActorTo(assertion.id)}"
                                                       immdediate="true"
                                                       value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                                       render="idSchemesForm,actorsForm,description"/>
                                    <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                       disabled="#{!appliesToActorManager.isActorSelected()}"
                                                       rendered="#{appliesToActorManager.isSelectedActorLinkedTo(assertion.id)}"
                                                       actionListener="#{appliesToActorManager.unlinkSelectedActorFrom(assertion.id)}"
                                                       immdediate="true"
                                                       value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                       render="idSchemesForm,actorsForm,description"/>
                                </g:column>
                                <ui:include src="_applyAssertionsTable.xhtml">
                                    <ui:param name="assertionParam" value="#{assertion}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="idSchemeDs"/>
                                        <ui:param name="dataTableId" value="idScheme"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>
                    </h:form>
                    <ui:include src="../_linkAllPopup.xhtml">
                        <ui:param name="manager" value="#{appliesToActorManager}"/>
                        <ui:param name="formToRender" value="actorsForm"/>
                    </ui:include>
                </div>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
